package org.jastadd.ragconnect.tests;

import org.junit.jupiter.api.Test;

import java.io.IOException;
import java.nio.file.*;
import java.util.Collections;

/**
 * Regression tests for fixed issues.
 *
 * @author rschoene - Initial contribution
 */
public class RegressionTests {

  private static final String REGRESSION_TEST_OUTPUT_DIRECTORY = "regression-test/";

  @Test
  public void issue27() throws IOException {
    String grammarFile = "regression-tests/issue27/Test.relast";
    String connectFile = "regression-tests/issue27/Test.connect";
    grammarFile = ensureNoTrailingNewLine(grammarFile);
    connectFile = ensureNoTrailingNewLine(connectFile);
    TestUtils.runCompiler(grammarFile, Collections.singletonList(connectFile), "A", REGRESSION_TEST_OUTPUT_DIRECTORY, 0);
  }

  private String ensureNoTrailingNewLine(String inputFileSuffix) throws IOException {
    int dotIndex = inputFileSuffix.lastIndexOf('.');
    String outFileSuffix = inputFileSuffix.substring(0, dotIndex) + ".noNewLine" + inputFileSuffix.substring(dotIndex);
    Path inputPath = Paths.get(TestUtils.INPUT_DIRECTORY_PREFIX).resolve(inputFileSuffix);
    Path outputPath = Paths.get(TestUtils.INPUT_DIRECTORY_PREFIX).resolve(outFileSuffix);

    String content = Files.readString(inputPath);
    Files.writeString(outputPath, content.stripTrailing(), StandardOpenOption.CREATE);

    return outFileSuffix;
  }
}
